--[[
	Idiomatic.lua -- a Class to assist in the creation of various Pd templated objects and constructs.
	
	The basic premise is to create a Pd Patch that consists of the template for what you wish to create
	an idiom, or object groupd collection.
--]]

local ClassName = "Idiomatic"

Idiomatic = pd.Class:new():register(ClassName)

function Idiomatic:initialize(name, atoms)
	pd.post("initialize")
	
	self.inlets = 1
	self.outlets = 1
	
	return true
end

function Idiomatic:postinitialize()
	pd.post("postinitialize")
end

--[[
function Idiomatic:in_1(sel, atoms)
	local i
	pd.post("selector = " .. tostring(sel))
	
	for i = 1, #atoms do
		pd.post("  atoms[" .. i .. "] = " .. atoms[i])
	end
end

function Idiomatic:in_1_bang()
	pd.post("Banging the hell out of it...")
end
--]]

function Idiomatic:in_1_list(atoms)
	if #atoms == 2 then
		-- we have two symbols, make sure the second is not 'symbol'
		if atoms[2] ~= 'symbol' then
			local file = io.open(atoms[1], "r")
			local destination = atoms[2]
			-- pd.send(destination, "vis", { 1 })
			pd.send(destination, "clear")
			if file ~= nil then
				local line = file:read("*line") -- drop first line
				-- if line == nil then FILE IS EMPTY
				local finished = false
				local error = false
				repeat
					local done = false
					line = file:read("*line")
					if line ~= nil then
						line = line:sub(4)
						repeat
							if line:sub(line:len()) == ';' then
								done = true
								line = line:sub(1, line:len() - 1)
							else
								local append = file:read("*line")
								if append == nil then
									-- this is an error
									done = true
									finished = true
									error = true
								else
									line = line .. ' ' .. append
								end
							end
						until done
						pd.post(line)
						if error == false then
							-- dispatch the message
							local tkn
							local tokens = {}
							local tokens2 = {}
							local i
							for tkn in line:gmatch("[^%s]+") do
								-- pd.post("     tkn = " .. tkn)
								local x = tonumber(tkn)
								if x then
									tokens[#tokens + 1] = x
								else
									tokens[#tokens + 1] = tkn
								end
							end
							tkn = tokens[1]
							for i = 2, #tokens do
								tokens2[#tokens2 + 1] = tokens[i]
							end
							---[[
							pd.post("destination: " .. destination)
							pd.post("tkn: " .. tkn)
							for i = 1, #tokens2 do
								pd.post("  element[" .. i .. "]: " .. tokens2[i])
							end
							--]]
							pd.send(destination, tkn, tokens2)
						end
					else
						finished = true
					end
				until finished
			else
				pd.post(string.format("%s: idiom does not exist.", ClassName))
			end
		else
			pd.post(string.format("%s: please specify the subpatch name", ClassName))
		end
	else
		-- report the error
		pd.post(string.format("%s: requires two symbols <fullpath-to-idiom> <pd-subpatch-name>", ClassName))
	end
end
